Index: pjproject/trunk/pjlib/build/pjlib_test.dsp
===================================================================
--- pjproject/trunk/pjlib/build/pjlib_test.dsp	(revision 104)
+++ pjproject/trunk/pjlib/build/pjlib_test.dsp	(revision 105)
@@ -51,5 +51,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjlib-test-i386-win32-vc6-release.exe"
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /profile /debug /machine:I386 /out:"../bin/pjlib-test-i386-win32-vc6-release.exe"
 
 !ELSEIF  "$(CFG)" == "pjlib_test - Win32 Debug"
Index: pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 104)
+++ pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 105)
@@ -94,5 +94,5 @@
 # Begin Source File
 
-SOURCE="..\src\test-pjsip\msg.c"
+SOURCE="..\src\test-pjsip\msg_test.c"
 # End Source File
 # Begin Source File
@@ -102,5 +102,5 @@
 # Begin Source File
 
-SOURCE="..\src\test-pjsip\uri.c"
+SOURCE="..\src\test-pjsip\uri_test.c"
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/include/pjsip/sip_config.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_config.h	(revision 105)
@@ -30,6 +30,6 @@
 #define PJSIP_MAX_TRANSPORTS		(PJ_IOQUEUE_MAX_HANDLES)
 #define PJSIP_MAX_PKT_LEN		1500
-#define PJSIP_POOL_LEN_RDATA		2500
-#define PJSIP_POOL_INC_RDATA		512
+#define PJSIP_POOL_RDATA_LEN		4000
+#define PJSIP_POOL_RDATA_INC		4000
 #define PJSIP_POOL_LEN_TRANSPORT	512
 #define PJSIP_POOL_INC_TRANSPORT	512
Index: pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 105)
@@ -249,5 +249,5 @@
 PJ_DECL(void) pjsip_endpt_resolve( pjsip_endpoint *endpt,
 				   pj_pool_t *pool,
-				   pjsip_host_port *target,
+				   pjsip_host_info *target,
 				   void *token,
 				   pjsip_resolver_callback *cb);
@@ -281,5 +281,6 @@
 PJ_DECL(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
 						  pjsip_transport_type_e type,
-						  const pj_sockaddr_in *remote,
+						  const pj_sockaddr *remote,
+						  int addr_len,
 						  pjsip_transport **p_transport);
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_resolve.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_resolve.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_resolve.h	(revision 105)
@@ -60,5 +60,8 @@
 
 	/** The server's address. */
-	pj_sockaddr_in		addr;
+	pj_sockaddr		addr;
+
+	/** Address length. */
+	int			addr_len;
 
     } entry[PJSIP_MAX_RESOLVED_ADDRESSES];
@@ -108,5 +111,5 @@
 PJ_DECL(void) pjsip_resolve( pjsip_resolver_t *resolver,
 			     pj_pool_t *pool,
-			     pjsip_host_port *target,
+			     pjsip_host_info *target,
 			     void *token,
 			     pjsip_resolver_callback *cb);
Index: pjproject/trunk/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 105)
@@ -108,5 +108,5 @@
      */
     pjsip_tsx_transport_state_e	transport_state;/**< Transport's state.     */
-    pjsip_host_port		dest_name;      /**< Destination address.   */
+    pjsip_host_info		dest_name;      /**< Destination address.   */
     pjsip_server_addresses	remote_addr;    /**< Addresses resolved.    */
     int				current_addr;   /**< Address currently used. */
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 105)
@@ -175,8 +175,14 @@
 
 	/** The source address from which the packet was received. */
-	pj_sockaddr_in		 addr;
+	pj_sockaddr		 src_addr;
 
 	/** The length of the source address. */
-	int			 addr_len;
+	int			 src_addr_len;
+
+	/** The IP source address string (NULL terminated). */
+	char			 src_name[16];
+
+	/** The IP source port number. */
+	int			 src_port;
 
     } pkt_info;
@@ -408,12 +414,19 @@
     int			    tracing;	    /**< Tracing enabled?	    */
 
-    pjsip_transport_type_e  type;	    /**< Transport type.	    */
-    char		    type_name[8];   /**< Type name.		    */
+    /** Key for indexing this transport in hash table. */
+    struct {
+	pjsip_transport_type_e  type;	    /**< Transport type.	    */
+	pj_sockaddr		rem_addr;   /**< Remote addr (zero for UDP) */
+    } key;
+
+    char		   *type_name;	    /**< Type name.		    */
     unsigned		    flag;	    /**< #pjsip_transport_flags_e   */
-
-    pj_sockaddr_in	    local_addr;	    /**< Bound address.		    */
-    pj_sockaddr_in	    public_addr;    /**< STUN addres.		    */
-    pj_sockaddr_in	    rem_addr;	    /**< Remote addr (zero for UDP) */
-
+    char		   *info;	    /**< Transport info/description.*/
+
+    int			    addr_len;	    /**< Length of addresses.	    */
+    pj_sockaddr		    local_addr;	    /**< Bound address.		    */
+    pjsip_host_port	    local_name;	    /**< Published name (eg. STUN). */
+    pjsip_host_port	    remote_name;    /**< Remote address name.	    */
+    
     pjsip_endpoint	   *endpt;	    /**< Endpoint instance.	    */
     pjsip_tpmgr		   *tpmgr;	    /**< Transport manager.	    */
@@ -429,4 +442,5 @@
      *			    caller when pending send operation completes.
      * @param rem_addr	    The remote destination address.
+     * @param addr_len	    Size of remote address.
      * @param callback	    If supplied, the callback will be called
      *			    once a pending transmission has completed. If
@@ -447,5 +461,6 @@
     pj_status_t (*send_msg)(pjsip_transport *transport, 
 			    pjsip_tx_data *tdata,
-			    const pj_sockaddr_in *rem_addr,
+			    const pj_sockaddr_t *rem_addr,
+			    int addr_len,
 			    void *token,
 			    void (*callback)(pjsip_transport *transport,
@@ -523,6 +538,6 @@
     unsigned		    flag;
 
-    pj_sockaddr_in	    local_addr;
-    pj_sockaddr_in	    public_addr;
+    pj_sockaddr		    local_addr;
+    pjsip_host_port	    addr_name;
 
     /**
@@ -532,5 +547,5 @@
 				    pjsip_tpmgr *mgr,
 				    pjsip_endpoint *endpt,
-				    const pj_sockaddr_in *rem_addr,
+				    const pj_sockaddr *rem_addr,
 				    pjsip_transport **transport);
 
@@ -608,7 +623,8 @@
  */
 PJ_DECL(pj_status_t) pjsip_tpmgr_alloc_transport( pjsip_tpmgr *mgr,
-					   pjsip_transport_type_e type,
-					   const pj_sockaddr_in *remote,
-					   pjsip_transport **p_transport );
+						  pjsip_transport_type_e type,
+						  const pj_sockaddr_t *remote,
+						  int addr_len,
+						  pjsip_transport **p_transport );
 
 
@@ -618,5 +634,6 @@
 PJ_DECL(pj_status_t) pjsip_transport_send( pjsip_transport *tr, 
 					   pjsip_tx_data *tdata,
-					   const pj_sockaddr_in *addr,
+					   const pj_sockaddr_t *addr,
+					   int addr_len,
 					   void *token,
 					   void (*cb)(void *token, 
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 105)
@@ -29,5 +29,7 @@
  * @param endpt		The SIP endpoint.
  * @param local		Local address to bind.
- * @param pub_addr	Public address to advertise.
+ * @param a_name	Published address (only the host and port portion is 
+ *			used). If this argument is NULL, then the bound address
+ *			will be used as the published address.
  * @param async_cnt	Number of simultaneous async operations.
  * @param p_transport	Pointer to receive the transport.
@@ -39,5 +41,5 @@
 PJ_DECL(pj_status_t) pjsip_udp_transport_start(pjsip_endpoint *endpt,
 					       const pj_sockaddr_in *local,
-					       const pj_sockaddr_in *pub_addr,
+					       const pjsip_host_port *a_name,
 					       unsigned async_cnt,
 					       pjsip_transport **p_transport);
@@ -48,5 +50,6 @@
  * @param endpt		The SIP endpoint.
  * @param sock		UDP socket to use.
- * @param pub_addr	Public address to advertise.
+ * @param a_name	Published address (only the host and port portion is 
+ *			used).
  * @param async_cnt	Number of simultaneous async operations.
  * @param p_transport	Pointer to receive the transport.
@@ -58,5 +61,5 @@
 PJ_DECL(pj_status_t) pjsip_udp_transport_attach(pjsip_endpoint *endpt,
 						pj_sock_t sock,
-						const pj_sockaddr_in *pub_addr,
+						const pjsip_host_port *a_name,
 						unsigned async_cnt,
 						pjsip_transport **p_transport);
Index: pjproject/trunk/pjsip/include/pjsip/sip_types.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 105)
@@ -146,9 +146,17 @@
 typedef struct pjsip_host_port
 {
-    unsigned flag;	/**< Flags of pjsip_transport_flags_e (not used in Via). */
-    unsigned type;	/**< Transport type (pjsip_transport_type_e), or zero. */
-    pj_str_t host;	/**< Host part. */
+    pj_str_t host;	/**< Host part or IP address. */
     int	     port;	/**< Port number. */
 } pjsip_host_port;
+
+/**
+ * Host information.
+ */
+typedef struct pjsip_host_info
+{
+    unsigned		    flag;   /**< Flags of pjsip_transport_flags_e. */
+    pjsip_transport_type_e  type;   /**< Transport type. */
+    pjsip_host_port	    addr;   /**< Address information. */
+} pjsip_host_info;
 
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_util.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 104)
+++ pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 105)
@@ -181,5 +181,5 @@
 					     const pjsip_transport *tr,
 					     const pjsip_via_hdr *via,
-					     pjsip_host_port *addr);
+					     pjsip_host_info *addr);
 
 /**
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 104)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 105)
@@ -726,6 +726,6 @@
 
     if (status != PJ_SUCCESS) {
-	const char *src_addr = pj_inet_ntoa(rdata->pkt_info.addr.sin_addr);
-	int port = pj_ntohs(rdata->pkt_info.addr.sin_port);
+	const char *src_addr = rdata->pkt_info.src_name;
+	int port = rdata->pkt_info.src_port;
 	PJSIP_ENDPT_LOG_ERROR((endpt, "transport", status,
 			       "Src.addr=%s:%d, packet:--\n"
@@ -741,18 +741,16 @@
      */
     if (msg->type == PJSIP_RESPONSE_MSG) {
-	const pj_sockaddr_in *addr;
-	const char *addr_addr;
+	const pj_str_t *addr_addr;
 	int port = rdata->msg_info.via->sent_by.port;
 	pj_bool_t mismatch = PJ_FALSE;
 	if (port == 0) {
 	    int type;
-	    type = rdata->tp_info.transport->type;
+	    type = rdata->tp_info.transport->key.type;
 	    port = pjsip_transport_get_default_port_for_type(type);
 	}
-	addr = &rdata->tp_info.transport->public_addr;
-	addr_addr = pj_inet_ntoa(addr->sin_addr);
-	if (pj_strcmp2(&rdata->msg_info.via->sent_by.host, addr_addr) != 0)
+	addr_addr = &rdata->tp_info.transport->local_name.host;
+	if (pj_strcmp(&rdata->msg_info.via->sent_by.host, addr_addr) != 0)
 	    mismatch = PJ_TRUE;
-	else if (port != pj_ntohs(addr->sin_port)) {
+	else if (port != rdata->tp_info.transport->local_name.port) {
 	    /* Port or address mismatch, we should discard response */
 	    /* But we saw one implementation (we don't want to name it to 
@@ -762,5 +760,5 @@
 	     * both the port in sent-by and rport. We try to be lenient here!
 	     */
-	    if (rdata->msg_info.via->rport_param != pj_sockaddr_in_get_port(addr))
+	    if (rdata->msg_info.via->rport_param != rdata->tp_info.transport->local_name.port)
 		mismatch = PJ_TRUE;
 	    else {
@@ -959,5 +957,5 @@
 PJ_DEF(void) pjsip_endpt_resolve( pjsip_endpoint *endpt,
 				  pj_pool_t *pool,
-				  pjsip_host_port *target,
+				  pjsip_host_info *target,
 				  void *token,
 				  pjsip_resolver_callback *cb)
@@ -988,10 +986,11 @@
 PJ_DEF(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
 						  pjsip_transport_type_e type,
-						  const pj_sockaddr_in *remote,
+						  const pj_sockaddr *remote,
+						  int addr_len,
 						  pjsip_transport **p_transport)
 {
     PJ_LOG(5, (THIS_FILE, "pjsip_endpt_alloc_transport()"));
-    return pjsip_tpmgr_alloc_transport( endpt->transport_mgr, type, remote,
-					p_transport);
+    return pjsip_tpmgr_alloc_transport( endpt->transport_mgr, type, 
+					remote, addr_len, p_transport);
 }
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_resolve.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 104)
+++ pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 105)
@@ -57,5 +57,5 @@
 PJ_DEF(void) pjsip_resolve( pjsip_resolver_t *resolver,
 			    pj_pool_t *pool,
-			    pjsip_host_port *target,
+			    pjsip_host_info *target,
 			    void *token,
 			    pjsip_resolver_callback *cb)
@@ -73,5 +73,5 @@
 
     /* Is it IP address or hostname?. */
-    is_ip_addr = is_str_ip(&target->host);
+    is_ip_addr = is_str_ip(&target->addr.host);
 
     /* Set the transport type if not explicitly specified. 
@@ -79,5 +79,5 @@
      */
     if (type == PJSIP_TRANSPORT_UNSPECIFIED) {
-	if (is_ip_addr || (target->port != 0)) {
+	if (is_ip_addr || (target->addr.port != 0)) {
 #if PJ_HAS_TCP
 	    if (target->flag & PJSIP_TRANSPORT_SECURE) 
@@ -104,15 +104,17 @@
 
     /* Set the port number if not specified. */
-    if (target->port == 0) {
-	target->port = pjsip_transport_get_default_port_for_type(type);
+    if (target->addr.port == 0) {
+	target->addr.port = pjsip_transport_get_default_port_for_type(type);
     }
 
     /* Resolve hostname. */
     if (!is_ip_addr) {
-	status = pj_sockaddr_in_init(&svr_addr.entry[0].addr, &target->host, 
-				     (pj_uint16_t)target->port);
+	status = pj_sockaddr_in_init((pj_sockaddr_in*)&svr_addr.entry[0].addr, 
+				     &target->addr.host, 
+				     (pj_uint16_t)target->addr.port);
     } else {
-	status = pj_sockaddr_in_init(&svr_addr.entry[0].addr, &target->host, 
-				     (pj_uint16_t)target->port);
+	status = pj_sockaddr_in_init((pj_sockaddr_in*)&svr_addr.entry[0].addr, 
+				      &target->addr.host, 
+				     (pj_uint16_t)target->addr.port);
 	pj_assert(status == PJ_SUCCESS);
     }
@@ -121,4 +123,5 @@
     svr_addr.count = (status == PJ_SUCCESS) ? 1 : 0;
     svr_addr.entry[0].type = type;
+    svr_addr.entry[0].addr_len = sizeof(pj_sockaddr_in);
     (*cb)(status, token, &svr_addr);
 }
Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 104)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 105)
@@ -499,5 +499,5 @@
 static pj_status_t tsx_process_route( pjsip_transaction *tsx,
 				      pjsip_tx_data *tdata,
-				      pjsip_host_port *send_addr )
+				      pjsip_host_info *send_addr )
 {
     const pjsip_uri *new_request_uri, *target_uri;
@@ -596,6 +596,6 @@
 	const pjsip_url *url = (const pjsip_url*)pjsip_uri_get_uri(uri);
 	send_addr->flag |= (PJSIP_TRANSPORT_SECURE | PJSIP_TRANSPORT_RELIABLE);
-	pj_strdup(tdata->pool, &send_addr->host, &url->host);
-        send_addr->port = url->port;
+	pj_strdup(tdata->pool, &send_addr->addr.host, &url->host);
+        send_addr->addr.port = url->port;
 	send_addr->type = 
             pjsip_transport_get_type_from_name(&url->transport_param);
@@ -604,6 +604,6 @@
 	pjsip_uri *uri = (pjsip_uri*) target_uri;
 	const pjsip_url *url = (const pjsip_url*)pjsip_uri_get_uri(uri);
-	pj_strdup(tdata->pool, &send_addr->host, &url->host);
-	send_addr->port = url->port;
+	pj_strdup(tdata->pool, &send_addr->addr.host, &url->host);
+	send_addr->addr.port = url->port;
 	send_addr->type = 
             pjsip_transport_get_type_from_name(&url->transport_param);
@@ -651,6 +651,6 @@
     struct tsx_lock_data lck;
 
-    pj_memcpy(addr, tsx->dest_name.host.ptr, tsx->dest_name.host.slen);
-    addr[tsx->dest_name.host.slen] = '\0';
+    pj_memcpy(addr, tsx->dest_name.addr.host.ptr, tsx->dest_name.addr.host.slen);
+    addr[tsx->dest_name.addr.host.slen] = '\0';
 
 
@@ -658,9 +658,9 @@
 	PJ_LOG(4, (tsx->obj_name, "%s connected to %s:%d",
 				  tr->type_name,
-				  addr, tsx->dest_name.port));
+				  addr, tsx->dest_name.addr.port));
     } else {
 	PJ_LOG(4, (tsx->obj_name, "%s unable to connect to %s:%d, status=%d", 
 				  tr->type_name,
-				  addr, tsx->dest_name.port, status));
+				  addr, tsx->dest_name.addr.port, status));
     }
 
@@ -738,11 +738,8 @@
 
     /* Create/find the transport for the remote address. */
-    PJ_LOG(5,(tsx->obj_name, "tsx getting transport for %s:%d",
-			     pj_inet_ntoa(addr->entry[0].addr.sin_addr),
-			     pj_ntohs(addr->entry[0].addr.sin_port)));
-
     tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_CONNECTING;
     status = pjsip_endpt_alloc_transport( tsx->endpt, addr->entry[0].type,
 					  &addr->entry[0].addr,
+					  addr->entry[0].addr_len,
 					  &tp);
     tsx_transport_callback(tp, tsx, status);
@@ -852,7 +849,7 @@
      */
     PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-			     tsx->dest_name.host.slen, 
-			     tsx->dest_name.host.ptr,
-			     tsx->dest_name.port));
+			     tsx->dest_name.addr.host.slen, 
+			     tsx->dest_name.addr.host.ptr,
+			     tsx->dest_name.addr.port));
 
     tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
@@ -942,7 +939,7 @@
 	tsx->current_addr = 0;
 	tsx->remote_addr.count = 1;
-	tsx->remote_addr.entry[0].type = tsx->transport->type;
+	tsx->remote_addr.entry[0].type = tsx->transport->key.type;
 	pj_memcpy(&tsx->remote_addr.entry[0].addr, 
-		  &rdata->pkt_info.addr, rdata->pkt_info.addr_len);
+		  &rdata->pkt_info.src_addr, rdata->pkt_info.src_addr_len);
 	
     } else {
@@ -965,7 +962,7 @@
 	 */
 	PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-				 tsx->dest_name.host.slen, 
-				 tsx->dest_name.host.ptr,
-				 tsx->dest_name.port));
+				 tsx->dest_name.addr.host.slen, 
+				 tsx->dest_name.addr.host.ptr,
+				 tsx->dest_name.addr.port));
 
 	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
@@ -1024,5 +1021,5 @@
 {
     pjsip_msg *msg;
-    pjsip_host_port dest_addr;
+    pjsip_host_info dest_addr;
     pjsip_via_hdr *via;
     struct tsx_lock_data lck;
@@ -1060,6 +1057,6 @@
     if (dest_addr.type == tsx->dest_name.type &&
 	dest_addr.flag == tsx->dest_name.flag &&
-	dest_addr.port == tsx->dest_name.port &&
-	pj_stricmp(&dest_addr.host, &tsx->dest_name.host) == 0)
+	dest_addr.addr.port == tsx->dest_name.addr.port &&
+	pj_stricmp(&dest_addr.addr.host, &tsx->dest_name.addr.host) == 0)
     {
 	/* Equal destination. We can use current transport. */
@@ -1072,10 +1069,10 @@
     /* New destination; we'll have to resolve host and create new transport. */
     pj_memcpy(&tsx->dest_name, &dest_addr, sizeof(dest_addr));
-    pj_strdup(tsx->pool, &tsx->dest_name.host, &dest_addr.host);
+    pj_strdup(tsx->pool, &tsx->dest_name.addr.host, &dest_addr.addr.host);
 
     PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-			     tsx->dest_name.host.slen, 
-			     tsx->dest_name.host.ptr,
-			     tsx->dest_name.port));
+			     tsx->dest_name.addr.host.slen, 
+			     tsx->dest_name.addr.host.ptr,
+			     tsx->dest_name.addr.port));
 
     tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_RESOLVING;
@@ -1216,5 +1213,4 @@
 	 */
 	if (tdata->msg->type == PJSIP_REQUEST_MSG) {
-	    const pj_sockaddr_in *addr_name;
 	    pjsip_via_hdr *via = (pjsip_via_hdr*) 
 		pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
@@ -1226,10 +1222,9 @@
 	    /* Don't update Via sent-by on retransmission. */
 	    if (via->sent_by.host.slen == 0) {
-		addr_name = &tsx->transport->public_addr;
 		pj_strdup2(tdata->pool, &via->transport, 
 			   tsx->transport->type_name);
-		pj_strdup2(tdata->pool, &via->sent_by.host, 
-			   pj_inet_ntoa(addr_name->sin_addr));
-		via->sent_by.port = pj_ntohs(addr_name->sin_port);
+		pj_strdup(tdata->pool, &via->sent_by.host, 
+			  &tsx->transport->local_name.host);
+		via->sent_by.port = tsx->transport->local_name.port;
 	    }
 	}
@@ -1243,4 +1238,5 @@
 	status = pjsip_transport_send(tsx->transport, tdata,
 			&tsx->remote_addr.entry[tsx->current_addr].addr,
+			tsx->remote_addr.entry[tsx->current_addr].addr_len,
 			tsx, &tsx_on_send_complete);
 	if (status != PJ_SUCCESS && status != PJ_EPENDING) {
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 104)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 105)
@@ -47,6 +47,4 @@
 };
 
-
-
 /*****************************************************************************
  *
@@ -82,4 +80,11 @@
     unsigned i;
 
+    /* Sanity check. 
+     * Check that transport_names[] are indexed on transport type. 
+     */
+    PJ_ASSERT_RETURN(transport_names[PJSIP_TRANSPORT_UDP].type ==
+		     PJSIP_TRANSPORT_UDP, PJSIP_TRANSPORT_UNSPECIFIED);
+
+    /* Get transport type from name. */
     for (i=0; i<PJ_ARRAY_SIZE(transport_names); ++i) {
 	if (pj_stricmp(name, &transport_names[i].name) == 0) {
@@ -101,4 +106,11 @@
     unsigned i;
 
+    /* Sanity check. 
+     * Check that transport_names[] are indexed on transport type. 
+     */
+    PJ_ASSERT_RETURN(transport_names[PJSIP_TRANSPORT_UDP].type ==
+		     PJSIP_TRANSPORT_UDP, PJSIP_TRANSPORT_UNSPECIFIED);
+
+    /* Get the transport type for the specified flags. */
     for (i=0; i<PJ_ARRAY_SIZE(transport_names); ++i) {
 	if (transport_names[i].flag == flag) {
@@ -114,5 +126,14 @@
 pjsip_transport_get_flag_from_type( pjsip_transport_type_e type )
 {
+    /* Sanity check. 
+     * Check that transport_names[] are indexed on transport type. 
+     */
+    PJ_ASSERT_RETURN(transport_names[PJSIP_TRANSPORT_UDP].type ==
+		     PJSIP_TRANSPORT_UDP, 0);
+
+    /* Check that argument is valid. */
     PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 0);
+
+    /* Return transport flag. */
     return transport_names[type].flag;
 }
@@ -124,5 +145,14 @@
 pjsip_transport_get_default_port_for_type(pjsip_transport_type_e type)
 {
+    /* Sanity check. 
+     * Check that transport_names[] are indexed on transport type. 
+     */
+    PJ_ASSERT_RETURN(transport_names[PJSIP_TRANSPORT_UDP].type ==
+		     PJSIP_TRANSPORT_UDP, 0);
+
+    /* Check that argument is valid. */
     PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 5060);
+
+    /* Return the port. */
     return transport_names[type].port;
 }
@@ -225,15 +255,4 @@
  *****************************************************************************/
 
-/*
- * Transport key for indexing in the hash table.
- */
-typedef struct transport_key
-{
-    pj_uint8_t	type;
-    pj_uint8_t	zero;
-    pj_uint16_t	port;
-    pj_uint32_t	addr;
-} transport_key;
-
 
 /*****************************************************************************
@@ -270,5 +289,6 @@
 PJ_DEF(pj_status_t) pjsip_transport_send(  pjsip_transport *tr, 
 					   pjsip_tx_data *tdata,
-					   const pj_sockaddr_in *addr,
+					   const pj_sockaddr *addr,
+					   int addr_len,
 					   void *token,
 					   void (*cb)(void *token, 
@@ -318,5 +338,5 @@
 
     /* Send to transport. */
-    status = (*tr->send_msg)(tr, tdata,  addr, (void*)tdata, 
+    status = (*tr->send_msg)(tr, tdata,  addr, addr_len, (void*)tdata, 
 			     &transport_send_callback);
 
@@ -396,5 +416,5 @@
 					      pjsip_transport *tp )
 {
-    transport_key key;
+    int key_len;
 
     /* Init. */
@@ -407,11 +427,7 @@
      * Register to hash table.
      */
-    key.type = (pj_uint8_t)tp->type;
-    key.zero = 0;
-    key.addr = pj_ntohl(tp->rem_addr.sin_addr.s_addr);
-    key.port = pj_ntohs(tp->rem_addr.sin_port);
-
+    key_len = sizeof(tp->key.type) + tp->addr_len;
     pj_lock_acquire(mgr->lock);
-    pj_hash_set(tp->pool, mgr->table, &key, sizeof(key), tp);
+    pj_hash_set(tp->pool, mgr->table, &tp->key, key_len, tp);
     pj_lock_release(mgr->lock);
 
@@ -426,6 +442,7 @@
 						pjsip_transport *tp)
 {
-    transport_key key;
-
+    int key_len;
+
+    /* Must have no user. */
     PJ_ASSERT_RETURN(pj_atomic_get(tp->ref_cnt) == 0, PJSIP_EBUSY);
 
@@ -445,10 +462,6 @@
      * Unregister from hash table.
      */
-    key.type = (pj_uint8_t)tp->type;
-    key.zero = 0;
-    key.addr = pj_ntohl(tp->rem_addr.sin_addr.s_addr);
-    key.port = pj_ntohs(tp->rem_addr.sin_port);
-
-    pj_hash_set(tp->pool, mgr->table, &key, sizeof(key), NULL);
+    key_len = sizeof(tp->key.type) + tp->addr_len;
+    pj_hash_set(tp->pool, mgr->table, &tp->key, key_len, NULL);
 
     pj_lock_release(mgr->lock);
@@ -602,5 +615,4 @@
 {
     pjsip_transport *tr = rdata->tp_info.transport;
-    pj_str_t s;
 
     char *current_pkt;
@@ -683,8 +695,10 @@
   	 * MUST add received parameter to the via.
 	 */
-	s = pj_str(pj_inet_ntoa(rdata->pkt_info.addr.sin_addr));
-	if (pj_strcmp(&s, &rdata->msg_info.via->sent_by.host) != 0) {
-	    pj_strdup(rdata->tp_info.pool, 
-		      &rdata->msg_info.via->recvd_param, &s);
+	if (pj_strcmp2(&rdata->msg_info.via->sent_by.host, 
+		       rdata->pkt_info.src_name) != 0) 
+	{
+	    pj_strdup2(rdata->tp_info.pool, 
+		       &rdata->msg_info.via->recvd_param, 
+		       rdata->pkt_info.src_name);
 	}
 
@@ -693,6 +707,5 @@
 	 */
 	if (rdata->msg_info.via->rport_param == 0) {
-	    rdata->msg_info.via->rport_param = 
-		pj_ntohs(rdata->pkt_info.addr.sin_port);
+	    rdata->msg_info.via->rport_param = rdata->pkt_info.src_port;
 	}
 
@@ -736,8 +749,14 @@
 PJ_DEF(pj_status_t) pjsip_tpmgr_alloc_transport( pjsip_tpmgr *mgr,
 						 pjsip_transport_type_e type,
-						 const pj_sockaddr_in *remote,
+						 const pj_sockaddr_t *remote,
+						 int addr_len,
 						 pjsip_transport **p_transport)
 {
-    transport_key key;
+    struct transport_key
+    {
+	pjsip_transport_type_e	type;
+	pj_sockaddr		addr;
+    } key;
+    int key_len;
     pjsip_transport *transport;
     pjsip_tpfactory *factory;
@@ -746,20 +765,29 @@
     pj_lock_acquire(mgr->lock);
 
+    key_len = sizeof(key.type) + addr_len;
+
     /* First try to get exact destination. */
-    key.type = (pj_uint8_t)type;
-    key.zero = 0;
-    key.addr = pj_ntohl(remote->sin_addr.s_addr);
-    key.port = pj_ntohs(remote->sin_port);
-
-    transport = pj_hash_get(mgr->table, &key, sizeof(key));
-    if (transport != NULL) {
+    key.type = type;
+    pj_memcpy(&key.addr, remote, addr_len);
+
+    transport = pj_hash_get(mgr->table, &key, key_len);
+    if (transport == NULL) {
 	unsigned flag = pjsip_transport_get_flag_from_type(type);
-	
-	/* For datagram transports, try lookup with zero address. */
-	if (flag & PJSIP_TRANSPORT_DATAGRAM) {
-	    key.addr = 0;
-	    key.port = 0;
-
-	    transport = pj_hash_get(mgr->table, &key, sizeof(key));
+	const pj_sockaddr *remote_addr = (const pj_sockaddr*)remote;
+
+	/* For datagram transports, try lookup with zero address. 
+	 */
+	if ( (flag & PJSIP_TRANSPORT_DATAGRAM) && 
+	     (remote_addr->sa_family == PJ_AF_INET)) 
+	{
+	    pj_sockaddr_in *addr = (pj_sockaddr_in*)&key.addr;
+
+	    pj_memset(addr, 0, sizeof(pj_sockaddr_in));
+	    addr->sin_family = PJ_AF_INET;
+	    addr->sin_addr.s_addr = 0;
+	    addr->sin_port = 0;
+
+	    key_len = sizeof(key.type) + sizeof(pj_sockaddr_in);
+	    transport = pj_hash_get(mgr->table, &key, key_len);
 	}
     }
@@ -816,20 +844,9 @@
 
 	do {
-	    char src_addr[128], dst_addr[128];
-	    int src_port, dst_port;
-	    pjsip_transport *t;
-
-	    t = pj_hash_this(mgr->table, itr);
-	    pj_native_strcpy(src_addr, pj_inet_ntoa(t->local_addr.sin_addr));
-	    src_port = pj_ntohs(t->local_addr.sin_port);
-
-	    pj_native_strcpy(dst_addr, pj_inet_ntoa(t->rem_addr.sin_addr));
-	    dst_port = pj_ntohs(t->rem_addr.sin_port);
-
-	    PJ_LOG(3, (THIS_FILE, "  %s %s %s:%d --> %s:%d (refcnt=%d)", 
-		       t->type_name,
+	    pjsip_transport *t = pj_hash_this(mgr->table, itr);
+
+	    PJ_LOG(3, (THIS_FILE, "  %s %s (refcnt=%d)", 
 		       t->obj_name,
-		       src_addr, src_port,
-		       dst_addr, dst_port,
+		       t->info,
 		       pj_atomic_get(t->ref_cnt)));
 
